      PROGRAM EX0704
      CHARACTER*10 FNAM(3)
      PARAMETER (IC=2)
      DIMENSION SLR(IC,IC),GR(IC,IC),V(IC,IC),AIJ(IC,IC),X(IC),G(IC)
      DATA FNAM/'WILSON    ','T-K-WILSON','NRTL      '/
      DATA SLR,GR/8*0./
      DATA V(1,1),V(1,2),V(2,1),V(2,2)/1.,0.494,2.024,1./
      DATA AIJ/4*0.2/
      DATA X(1),X(2),T/0.736,0.264,400./
C
C     WILSON (IOPT=1)
C
      SLR(1,2)= 209.8
      SLR(2,1)= 187.4
      CALL TKWILSON(IC,X,T,SLR,V,G,1)
      WRITE (*,1000) FNAM(1),G(1),G(2)
 1000 FORMAT(2X,A10,5X,'G1 =',F8.4,5X,'G2 =',F8.4)
C
C     T-K-WILSON (IOPT=2)
C
      SLR(1,2)= 163.39
      SLR(2,1)= 121.96
      CALL TKWILSON(IC,X,T,SLR,V,G,2)
      WRITE (*,1000) FNAM(2),G(1),G(2)
C
C     NRTL
C
      GR(1,2)=-299.33
      GR(2,1)= 684.69
      CALL NRTL(IC,X,T,GR,AIJ,G)
      WRITE(*,1000) FNAM(3),G(1),G(2)
      STOP
      END


	  
      SUBROUTINE TKWILSON
     &(IC,X,T,SLR,V,G,IOPT)
C
C     The subroutine calculates activity coefficients G(I) for the
C     Wilson (IOPT=1) and the T-K-Wilson (IOPT=2) models, for a
C     mixture at temperature T [K], of IC components each of 
C         molefraction X(I).
C     Other input required is
C     - SLR(I,J) : lamda(I,J)/R and
C     -  V (I,J) : molar volume of J / molar volume of I.
C
      DIMENSION X(IC),SLR(IC,IC),V(IC,IC),G(IC)
      DIMENSION AL(5,5),VV(5,5)
      DO 100 I=1,IC
      DO 100 J=1,IC
      AL(I,J)=V(I,J)*EXP(-SLR(I,J)/T)
      IF (IOPT.EQ.1) VV(I,J)=1.
  100 IF (IOPT.EQ.2) VV(I,J)=V(I,J)
      DO 500 I=1,IC
      SXV=0.
      SXL=0.
      DO 200 J=1,IC
      SXV=SXV+X(J)*VV(I,J)
  200 SXL=SXL+X(J)*AL(I,J)
      G11=LOG(SXV/SXL)
      SXK=0.
      DO 400 K=1,IC
      SXV=0.
      SXL=0.
      DO 300 J=1,IC
      SXV=SXV+X(J)*VV(K,J)
  300 SXL=SXL+X(J)*AL(K,J)
  400 SXK=SXK+X(K)*((VV(K,I)/SXV)-(AL(K,I)/SXL))
  500 G(I)=EXP(G11+SXK)
      RETURN
      END



	SUBROUTINE NRTL(IC,X,T,GR,AIJ,G)
C
C     The subroutine calculates activity coefficients G(I) for the
C     NRTL model, for a mixture at temperature T [K], of IC components
C     each of molefraction X(I).
C     Other input required is
C     - GR (I,J) : g(I,J)/R  and
C     - AIJ(I,J) : NRTL parameter a12 for binary mixture of I and J
C
      DIMENSION X(IC),GR(IC,IC),AIJ(IC,IC),G(IC)
      DIMENSION GC(5,5),TA(5,5)
      DO 100 I=1,IC
      DO 100 J=1,IC
      TA(I,J)=GR(I,J)/T
  100 GC(I,J)=EXP(-AIJ(I,J)*TA(I,J))
      DO 500 I=1,IC
      STXG=0.
      SXG=0.
      DO 200 K=1,IC
      STXG=STXG+TA(K,I)*X(K)*GC(K,I)
  200 SXG=SXG+X(K)*GC(K,I)
      G11=STXG/SXG
      S2PART=0.
      DO 400 J=1,IC
      SXG=0.
      SXTG=0.
      DO 300 K=1,IC
      SXG=SXG+X(K)*GC(K,J)
  300 SXTG=SXTG+X(K)*TA(K,J)*GC(K,J)
  400 S2PART=S2PART+(X(J)*GC(I,J)/SXG)*(TA(I,J)-(SXTG/SXG))
  500 G(I)=EXP(G11+S2PART)
      RETURN
      END
