      PROGRAM EX0806
      PARAMETER (IS=3)
      DIMENSION X(IS),Y(IS),Z(IS),PSAT(IS),EK(IS),FPUR(IS),F(IS),G(IS)
      DIMENSION TC(IS,IS),PC(IS,IS),OMEG(IS,IS),VP(IS,3)
      DIMENSION SLR(IS,IS),V(IS,IS)
      DATA (TC  (J,J),J=1,IS)/513.88,532.7,562.06/
      DATA (PC  (J,J),J=1,IS)/6.132E+6,3.780E+6,4.895E+6/
      DATA (OMEG(J,J),J=1,IS)/0.644,0.231,0.212/
      DATA (SLR (1,I),I=1,IS)/  0.  ,1109.61,699.11 /
      DATA (SLR (2,I),I=1,IS)/123.40,   0.  ,  6.693/
      DATA (SLR (3,I),I=1,IS)/ 63.06, 125.16,  0.   /
      DATA (VP  (1,I),I=1,3)/7.24222,1595.811,-46.702/
      DATA (VP  (2,I),I=1,3)/5.99178,1188.329,-46.843/
      DATA (VP  (3,I),I=1,3)/6.01905,1204.637,-53.081/
      DATA (V   (1,I),I=1,IS)/1.    ,0.5128,0.6538/
      DATA (V   (2,I),I=1,IS)/1.9501,1.    ,1.2750/
      DATA (V   (3,I),I=1,IS)/1.5295,0.7843,1.    /
C     /61.72,120.36,94.40/
      DATA P,T,Z/0.1E+6,341.21,0.76632,0.15576,0.07792/
      CALL FLASHTP
     &(IS,P,T,X,Y,Z,TC,PC,OMEG,VP,V,SLR,PSAT,EK,FPUR,F,G,BETA)
      WRITE (*,1100) T,P*1.E-6
 1100 FORMAT(1X,/,4X,'>>>  T=',F7.2,'K  &  P=',F6.3,'MPA'/,4X,72('-'),
     &/,13X,'Z(I)    X(I)    Y(I)',5X,'PSAT',6X,'K',5X,'FPUR',5X,'F',7X
     &,'G')
      DO 20 J=1,IS
   20 WRITE (*,1200) J,Z(J),X(J),Y(J),PSAT(J)/1.E+6,EK(J),FPUR(J),
     &F(J),G(J)
 1200 FORMAT(4X,'(',I1,')  ',3F8.4,2X,5F8.4)
      WRITE (*,1300) (1.-BETA),BETA
 1300 FORMAT(3X,'PHASE',/,3X,'KMOLES  1.000  ',2(F6.3,2X))
      END


      SUBROUTINE FLASHTP
     &(IS,P,T,X,Y,Z,TC,PC,OMEG,VP,V,SLR,PSAT,EK,FPUR,F,G,BETA)
C
C     The subroutine performs a Flash calculation at given P [Pa],T [K]
C     and the composition of the feed Z(I) of a multicomponent mixture
C     of IS components.
C        Method adopted is based on:
C     a) Activity coeficients, G(I),(supplied by another subroutine
C        say TKWILSON), and
C     b) Virial equation truncated to second coefficient (Tsonopoulos
C        expressions with Lorentz-Berthelot mixing rules).
C     -  Addiotional input to the subroutine are critical constants
C     TC(I,I) in [K], and PC(I,I) in [Pa], acentric factor OMEG(I,I),
C     and Antoine equation coeffs. VP(IS,3). For use by the TKWILSON
C     routine the molar volume ratios V(I,J) and the Wilson parameters
C     lamda/R, SLR(I,J) must be supplied.
C     -  Output includes vapour pressure PSAT(I), equilibrium constant
C     EK(I),pure fugacity coef.FPUR(I), component fugacity coef. F(I)
C     activity coefficients G(I), and the kmoles of vapour/feed, BETA.
C
      DIMENSION X(IS),Y(IS),Z(IS),PSAT(IS),EK(IS),FPUR(IS),F(IS),G(IS)
      DIMENSION TC(IS,IS),PC(IS,IS),OMEG(IS,IS),VP(IS,3),V(IS,IS)
      DIMENSION SLR(ISMIS),B(10,10),VC(10,10),ZC(10,10)
      R=8.3145
C
C     Mixture Critical TC(I,J), PC(I,J) (Lorentz-Berthelot Mixing Rules)
C
      DO 100 I=1,IS
  100 VC(I,I)=(0.291-0.080*OMEG(I,I))*R*TC(I,I)/PC(I,I)
      DO 120 I=1,IS
      DO 120 J=1,IS
      OMEG(I,J)=(OMEG(I,I)+OMEG(J,J))/2.
      ZC(I,J)=0.291-0.080*OMEG(I,J)
      VC(I,J)=(1./8.)*((VC(I,I)**(1./3.))+(VC(J,J)**(1./3.)))**3
      TC(I,J)=SQRT(TC(I,I)*TC(J,J))
  120 PC(I,J)=ZC(I,J)*R*TC(I,J)/VC(I,J)
C
C     Virial Coef. B(I,J) (Tsonopoulos Equations)
C
      DO 140 I=1,IS
      DO 140 J=1,IS
      TRI=TC(I,J)/T
  140 B(I,J)=R*TC(I,J)/PC(I,J)*(0.1445-0.33*TRI-0.1385*(TRI**2)-0.0121*
     &(TRI**3)-0.000607*(TRI**8)+OMEG(I,J)*(0.0637+0.331*(TRI**2)-0.423*
     &(TRI**3)-0.008*(TRI**8)))
C
C     Sat.Pressure PSAT(J), Pure Fugac.FPUR(J), first Equil.Const. EK(J)
C
      DO 160 J=1,IS
      PSAT(J)=1000.*(10.**(VP(J,1)-VP(J,2)/(T+VP(J,3))))
      FPUR(J)=EXP(B(J,J)*P/R/T)
  160 EK(J)=PSAT(J)*FPUR(J)/P
C
C     Calculate BETA & first X(I), Y(I)
C
   20 BETA=1.
   40 ST=0.
      SB=0.
      DO 180 I=1,IS
      ST=ST+Z(I)/(1.+BETA*(EK(I)-1.))
  180 SB=SB+Z(I)*(EK(I)-1.)/((1.+BETA*(EK(I)-1.))**2)
      BETAN=BETA+(ST-1.)/SB
      IF (ABS(BETAN-BETA).LE.0.000001) GOTO 60
      BETA=BETAN
      GOTO 40
   60 SX=0.
      SY=0.
      DO 200 I=1,IS
      X(I)=Z(I)/(1.+BETA*(EK(I)-1.))
      Y(I)=EK(I)*X(I)
      SX=SX+X(I)
  200 SY=SY+Y(I)
      DO 220 I=1,IS
      X(I)=X(I)/SX
  220 Y(I)=Y(I)/SY
C     WRITE(*,*) I,X(I),Y(I),BETA
C
C     Activity coefficient G(I) - via TKWILSON subroutine
C     Pure Fug.Coef. FPUR(I), Comp.Fug.Coef. F(I), Sat.Pressure PSAT(I)
C
      BMIX=0.
      DO 240 I=1,IS
      DO 240 J=1,IS
  240 BMIX=BMIX+Y(I)*Y(J)*B(I,J)
      CALL TKWILSON(IS,X,T,SLR,V,G,1)
      SYDIF=0.
      DO 280 I=1,IS
      FTERM=0.
      DO 260 K=1,IS
  260 FTERM=FTERM+Y(K)*B(K,I)
      F(I)=EXP(P/R/T*(2.*FTERM-BMIX))
      FPUR(I)=EXP(B(I,I)*P/R/T)
      PSAT(I)=1000.*(10.**(VP(I,1)-VP(I,2)/(T+VP(I,3))))
      EK(I)=G(I)*FPUR(I)*PSAT(I)/(P*F(I))
C
C     New Equilbrium Constant EK(I) - Check if Sum[abs(x*K-y)] = 0
C
      EK(I)=G(I)*FPUR(I)*PSAT(I)/(P*F(I))
  280 SYDIF=SYDIF+ABS(X(I)*EK(I)-Y(I))
      IF (SYDIF.GT.0.00001) GO TO 20
      RETURN
      END


      SUBROUTINE TKWILSON(IS,X,T,SLR,V,G,IOPT)
C
C     The subroutine calculates activity coefficients G(I) for the
C     Wilson (IOPT=1) and the T-K-Wilson (IOPT=2) models, for a mixture
C     at temperature T [K], of IS components each of molefraction X(I).
C     Other input required is
C     - SLR(I,J) : lamda(I,J)/R and
C     -  V (I,J) : molar volume of J / molar volume of I.
C
      DIMENSION X(IS),SLR(IS,IS),V(IS,IS),G(IS)
      DIMENSION AL(5,5),VV(5,5)
      DO 100 I=1,IS
      DO 100 J=1,IS
      AL(I,J)=V(J,I)*EXP(-SLR(I,J)/T)
      IF (IOPT.EQ.1) VV(J,I)=1.
  100 IF (IOPT.EQ.2) VV(J,I)=V(J,I)
      DO 500 I=1,IS
      SXV=0.
      SXL=0.
      DO 200 J=1,IS
      SXV=SXV+X(J)*VV(I,J)
  200 SXL=SXL+X(J)*AL(I,J)
      G11=LOG(SXV/SXL)
      SXK=0.
      DO 400 K=1,IS
      SXV=0.
      SXL=0.
      DO 300 J=1,IS
      SXV=SXV+X(J)*VV(K,J)
  300 SXL=SXL+X(J)*AL(K,J)
  400 SXK=SXK+X(K)*((VV(K,I)/SXV)-(AL(K,I)/SXL))
  500 G(I)=EXP(G11+SXK)
      RETURN
      END
